package cz.jzitnik.tui;

import javax.sound.sampled.*;

import lombok.extern.slf4j.Slf4j;

import java.io.IOException;

@Slf4j
public class SoundPlayer {
    public static Clip playSound(String filePath, int volume)
            throws LineUnavailableException, IOException, UnsupportedAudioFileException, InterruptedException {
        log.info("Loading resource: {}", "sounds/" + filePath);
        var soundFile = SoundPlayer.class.getClassLoader().getResourceAsStream("sounds/" + filePath);
        AudioInputStream audioStream = AudioSystem.getAudioInputStream(soundFile);
        Clip clip = AudioSystem.getClip();
        clip.open(audioStream);

        FloatControl volumeControl = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);
        float min = volumeControl.getMinimum();
        float max = volumeControl.getMaximum();
        float gain = min + (max - min) * (volume / 100.0f);
        volumeControl.setValue(gain);

        log.info("Starting to play {}", filePath);
        clip.start();

        // Thread.sleep(clip.getMicrosecondLength() / 1000);

        return clip;
    }
}
